/* Programme gnrateur de noms.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.2. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "Utilitaire.h"
#include "Rand.h"
#include "Fichier.h"
#include "Menu.h"
#include "Jdr.h"

int main (int argc,char *argv[])
{
    FILE* fichier;
    FILE* sortie;
    char chaine[255], race[255], sexe[255], tmpch[255];
    char type[10][6];   /*Tableau du type de nom = mode d'assemblage des fragments*/
    int i,j,index,nbfrag,alea,nblanC;
    long int index_fichier;
    Init_srand();
    init_historique_saisie();
    affichage_arg = 1;  //Affichage complet par defaut
    if(argc == 5)
    {
        Efface_char(argv[4],"=");
        affichage_arg = atoi(argv[4]);   /*Type d'affichage*/
    }
    if(affichage_arg == 1)
    {
        #ifdef WIN32    /*win*/
            Ph_jdr("..\\Phrases de jdr.txt");
        #endif
        Titre (argc,argv,"Name gen","Module gnrateur alatoire de noms",color_sd("Name gen",chfunc,argv));
        #ifndef WIN32    /*linux*/
            Ph_jdr("..\\Phrases de jdr.txt");
        #endif
    }
    if(argc>1)   /*Arguments*/
    {
        if(argc != 5)
        {
            #ifdef WIN32    /*win*/
                system("color FC");
            #endif
            putsacc("Erreur lors de l'excution de Name_gen.exe, nombre d'arguments incorrect !");
            Pause();
            exit(0);
        }
        Efface_char(argv[1],"=");
        strcpy(race,argv[1]); /*Prend la race, en 1er argument*/
        Efface_char(argv[2],"=");
        strcpy(sexe,argv[2]); /*Prend le sexe, en 2e argument*/
        Efface_char(argv[3],"=");
        nblanC = atoi(argv[3]); /*Prend le nombre de lancer, en 3e argument*/
    }
    if(argc==1)
    {   /*Si pas d'argument*/
        printf("Stocker directement les noms dans un fichier? (O/N, non par defaut): ");
        j = getchar();
        if (j == 79 || j == 111)
        {
            getchar();
            #ifdef WIN32    /*win*/
                system("\"Name_gen_txt.exe\"");
            #else /*linux*/
                system("\"./Name_gen_txt\"");
            #endif
            exit(0);
        }
        strcpy(chaine,Menu("Menu_nom.ini",chfunc,1,0));    /*Appel du menu*/
        i=0;
        while (chaine[i] != '>')
        {
            race[i] = chaine[i];    /*Rcupre la race dans la chaine renvoye par la chaine*/
            i++;
        }
        race[i] = '\0';        /*Termine la string*/
        j=0;
        i++;    /*Saute le >*/
        while (chaine[i] != '\0')
            sexe[j++] = chaine[i++];    /*Rcupre la sexe dans la chaine renvoye par la chaine*/
        sexe[j] = '\0';        /*Termine la string*/
        do
        {    /*Bcl d'erreur de saisie*/
            printf("Combien de nom voulez-vous ? ");
            nblanC = (int) interpret_calc("\0");
        } while (nblanC == NA || nblanC == defo);
        puts("");
    }
    sortie = ouvre_fichier ("Sortie name_gen.txt","w");
    fichier = ouvre_fichier ("Fragments de noms.nam","r");
    while (nblanC-- > 0)    /*Bcl sur le nombre de noms dsirs*/
    {
        chaine[0] = '0';    /*Modifie la chaine pour que la comparaison suivante soit effectue*/
        while (strcmp(chaine,race))    /*Rutilise la string chaine*/
        {    /*Repre la race slectione*/
            fgets(chaine,255,fichier);
            Efface_n(chaine);   //Supprime \n
            if (chaine[0] == '#')
            {        /*Retire le # avant la race*/
                for (i=0;i<(int)strlen(chaine);i++)
                    chaine [i] = chaine[i+1];
            }
        }
        fgets(chaine,255,fichier);            /*Passe  la ligne du type*/
        Efface_n(chaine);   //Supprime \n
        for(j=0;j<5;j++)
        {    /*Retire "type:" de la chaine*/
            for (i=0;i<(int)strlen(chaine);i++)
                chaine[i] = chaine[i+1];
        }
        index = 0;
        j=0;
        while (chaine[index] != '\0')    /*Decomposition du type*/
        {
            i=0;
            while (chaine[index] != '+' && chaine[index] != '\0')    /*Lit chaque partie du type*/
                type[j][i++] = chaine[index++];  /*Place dans le tableau de type*/
            type[j][i] = '\0';            /*Termine la saisie de chaque partie par un \0*/
            index++;
            j++;
        }
        type[j][0] = '\0';        /*Termine la saisie du type par un \0*/
        index=0;              /*Rutilise int index pour type de nom*/
        chaine[0] = '0';    /*Juste pour s'assurer qu'il ne trouve pas la mme chose dans la comparaison suivante*/
        if(affichage_arg < 3)
            puts("");
        fprintf(sortie,"\n");
        do
        {
            strcpy(tmpch,type[index]);    /*tmpch prend chaque partie du type*/
            nbfrag = 1; /*Initialise le nb de fragment  1 seul*/
            if (tmpch[0] == 'd')        /*Si le type demande un jet de ds*/
            {
                for (i=0;i<(int)strlen(tmpch);i++)
                    tmpch[i] = tmpch[i+1];     /*Retire d*/
                nbfrag = NbAlea1b(atoi(tmpch));    /*effectue le jet de d*/
                Efface_char(tmpch,"*");
            }
            do
            {        /*Boucle pour trouver les bons fragments de noms*/
                fgets(chaine,255,fichier);    /*Prend la ligne suivante*/
                Efface_n(chaine);   //Supprime \n
                if(strlen(chaine))  //Ignore si la ligne est vide
                    chaine[strlen(chaine)-1] = '\0';    //Supprime le :  la fin du type recherch
            } while (strcmp(chaine,tmpch));
            while (nbfrag-- > 0)    /*Bcl sur le nb de jet pour ce fragment*/
            {
                index_fichier = ftell(fichier);   /*Sauvegarde l'emplacement du curseur, au dbut des fragments*/
                fgets(chaine,255,fichier);        /*Lit le jet de d  effectuer*/
                Efface_n(chaine);   //Supprime \n
                if (chaine[0] != 'd')            /*Si c'est pas un jet de d*/
                {
                    if(strlen(chaine))  //Ignore si la ligne est vide
                        chaine[strlen(chaine)-1] = '\0';    //Supprime le :  la fin du sexe recherch
                    while (strcmp(chaine,sexe) != 0)           /*Cherche le sexe correspondant*/
                    {
                        fgets(chaine,255,fichier);
                        Efface_n(chaine);   //Supprime \n
                        if(strlen(chaine))  //Ignore si la ligne est vide
                            chaine[strlen(chaine)-1] = '\0';    //Supprime le :  la fin du sexe recherch
                    }
                    fgets(chaine,255,fichier);
                }
                for (i=0;i<(int)strlen(chaine);i++)    /*Retire 'd'*/
                    chaine[i] = chaine[i+1];
                alea = NbAlea1b(atoi(chaine));      /*jet alatoire pour dtermination du fragment*/
                if (alea != 1)            /*Si obtient pas 1 au jet de d*/
                {
                    do
                    {
                        fgets(chaine,255,fichier);  /*Saisi la ligne suivante*/
                        for(i=0;i<2;i++)
                        {
                            for(j=0;j<(int)strlen(chaine);j++)    /*Retire le 0 et le ':'*/
                                chaine[j] = chaine[j+1];
                        }
                    } while (atoi(chaine) != alea);   /*Reboucle tant qu'on retrouve pas la valeur du d*/
                }
                else  /*Si on a obtenu 1 au d*/
                {
                    do
                    {
                        for (i=0;i<(int)strlen(chaine);i++)
                            chaine[i] = chaine[i+1];
                    } while (chaine[0] != ':');       /*Retire la valeur du d*/
                }
                do
                {
                    for (i=0;i<(int)strlen(chaine);i++)    /*Retire la valeur avant le fragment*/
                        chaine[i] = chaine[i+1];
                } while (chaine[0] != ':');
                for (i=0;i<(int)strlen(chaine);i++)        /*Retire le ':' juste avant le fragment*/
                    chaine[i] = chaine[i+1];
                Efface_n(chaine);   //Supprime \n
                fseek(fichier,index_fichier,SEEK_SET); /*Retourne au dbut des fragments*/
                if(affichage_arg < 3)
                    putsacc(chaine);
                fprintf(sortie,"%s",chaine);
            }
            index++;
            if(type[index][0] == '\0' || type[index][0] == '\n')    //Fin lorsque le type suivant est \0 ou \n
                index=-1;
        }while (index != -1); /*Tant qu'il reste encore des parties dans le type*/
        rewind(fichier);
    }
    if(affichage_arg < 3)
        puts("");
    fprintf(sortie,"\n");
    fclose(fichier);
    fclose(sortie);
    if(argc==1)   /*Si pas d'argument*/
        Pause();
    return 0;
}
