/* Programme gnrateur de noms.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.1. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "Utilitaire.h"
#include "Rand.h"
#include "Fichier.h"
#include "Menu.h"
#include "Jdr.h"

int main (int argc,char *argv[])
{
    FILE* fichier;
    char chaine[100], prenom[255], nom[255];
    int i,j,pn=0,alea,nblanC;
    Init_srand();
    init_historique_saisie();
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre (argc,argv,"Name gen 2","Module gnrateur alatoire de noms contemporains",color_sd("Name gen 2",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    strcpy(chaine,Menu("Menu_prenom_nom.ini",chfunc,1,0));    /*Appel du menu*/
    i=0;
    while (chaine[i] != '>')
    {
        prenom[i] = chaine[i];    /*Rcupre la table de prnom dans la chaine renvoye par la chaine*/
        i++;
    }
    prenom[i] = '\0';        /*Termine la string*/
    j=0;
    i++;    /*Saute le >*/
    while (chaine[i] != '\0')
        nom[j++] = chaine[i++];    /*Rcupre la table de nom de famille dans la chaine renvoye par la chaine*/
    nom[j] = '\0';        /*Termine la string*/
    do
    {    /*Bcl d'erreur de saisie*/
        printf("Combien de nom voulez-vous ? ");
        nblanC = (int) interpret_calc("\0");
    } while (nblanC == NA || nblanC == defo);
    puts("");
    nblanC *= 2; /*multiplie par 2 le nombre de lanc pour compenser la boucle prnom->nom*/
    while (nblanC-- > 0)    /*Bcl sur le nombre de noms dsirs*/
    {
        if(!pn) /*Si pn = 0, on tire le prnom*/
        {
            fichier = ouvre_fichier (prenom,"r");
            pn=1;
        }
        else    /*donc pn = 1, le prnom est dj tir, on tire maintenant le nom de famille*/
        {
            fichier = ouvre_fichier (nom,"r");
            pn=0;
        }
        fgets(chaine,100,fichier);        /*Lit le jet de d  effectuer*/
        for (i=0;i<(int)strlen(chaine);i++)    /*Retire 'd'*/
            chaine[i] = chaine[i+1];
        alea = NbAlea1b(atoi(chaine));      /*jet alatoire pour dtermination du nom ou prnom*/
        if (alea != 1)            /*Si obtient pas 1 au jet de d*/
        {
            do
            {
                fgets(chaine,100,fichier);  /*Saisi la ligne suivante*/
                for(i=0;i<2;i++)
                {
                    for(j=0;j<(int)strlen(chaine);j++)    /*Retire le 0 et le ':'*/
                    chaine[j] = chaine[j+1];
                }
            } while (atoi(chaine) != alea);   /*Reboucle tant qu'on retrouve pas la valeur du d*/
        }
        else  /*Si on a obtenu 1 au d*/
        {
            do
            {
                for (i=0;i<(int)strlen(chaine);i++)
                    chaine[i] = chaine[i+1];
            } while (chaine[0] != ':');       /*Retire la valeur du d*/
        }
        do
        {
            for (i=0;i<(int)strlen(chaine);i++)    /*Retire la valeur avant le nom ou prenom*/
                chaine[i] = chaine[i+1];
        } while (chaine[0] != ':');
        for (i=0;i<(int)strlen(chaine);i++)        /*Retire le ':' juste avant le nom ou prenom*/
            chaine[i] = chaine[i+1];
        Efface_n(chaine);      //Retire le \n
        putsacc(chaine);
        if(pn) /*si pn = 1, prnom tir, pas le nom de famille*/
            printf(" "); /*Place un espace entre le prnom et le nom*/
        else    /*sinon, le nom est tir. Donc changement de ligne*/
            puts("");
        fclose(fichier);
    }
    Pause();
    return 0;
}
