/* Programme de gnration alatoire d'objets d'arts.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 1.1. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <string.h>
#include "Rand.h"
#include "Utilitaire.h"
#include "Fichier.h"
#include "Jdr.h"

void interpreteur (char* ligne, char *objet, float *prix); /*Traite les chaines renvoyes*/
char* gen_alea (const char* nomfichier, char* ligne);      /*Appel le gen alea en ligne de commande*/

int main (int argc,char *argv[])
{
    Init_srand();
    init_historique_saisie();
    char chaine[255];
    int nb;
    float prix=0;
    char objet[255];
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre(argc,argv,"Gnrateur d'objets d'arts","Programme de gnration alatoire d'objets d'arts pour donjons et dragons",color_sd("Generateur d'objets d'arts",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    do
    {    /*Bcl erreur de saisie*/
        putsacc("Nombre d'objets d'arts  gnrer: ");
        nb = (int) interpret_calc("\0");
    } while (nb == NA || nb == defo);
    for(;nb>0;nb--,prix=0)
    {
        objet[0] = '\0';    /*Initialise la string pour le strcat*/
        interpreteur(gen_alea("..\\Objets arts\\Objet.tbl",chaine),objet,&prix);
        interpreteur(gen_alea("..\\Objets arts\\Matire.tbl",chaine),objet,&prix);
        interpreteur(gen_alea("..\\Objets arts\\Dcoration.tbl",chaine),objet,&prix);
        puts("");
        putsacc(objet);
        printf("\nValeur: %.0f po\n", prix);
    }
    Pause();
    return 0;
}

void interpreteur (char* ligne, char *objet, float *prix)
{
    int i=0;
    char temp[255];
    while(ligne[i] != ':')
    {
        temp [i] = ligne[i];
        i++;
    }
    i += strlen(objet);        /*Truc de merde pour termin la chaine...*/
    strcat(objet,temp);
    objet[i] = '\0';           /*...ici*/
    Efface_char(ligne,":");
    if (ligne[0] == '+')   /*+ prix*/
    {
        Efface_char(ligne,"+");
        *prix += atof(ligne);    /*Dtermine l'augmentation du prix de l'objet*/
    }
    if (ligne[0] == '*')
    {
        Efface_char(ligne,"*");
        *prix *= atof(ligne);    /*Multiplie le prix de l'objet*/
    }
}

char* gen_alea (const char* nomfichier, char* ligne)
{
    FILE* temp;
    #ifdef WIN32    /*win*/
        sprintf(ligne,"cd \"..\\Gnrateur alatoire\" && Generateur_aleatoire.exe Table=\"%s\" Nombre=1 Affichage=3", nomfichier);
    #else /*linux*/
        sprintf(ligne,"cd \"../%s\" && ./Generateur_aleatoire Table=\"%s\" Nombre=1 Affichage=3", linux_acc("Gnrateur alatoire",chfunc),nomfichier);
    #endif
    system(ligne); /*Appel le gnrateur alatoire en ligne de commande*/
    temp = ouvre_fichier("..\\Gnrateur alatoire\\Sortie gen_alea.txt","r");
    do
    {
        fgets(ligne,255,temp);  /*Lit le rsultat du gnrateur alatoire*/
    }while(ligne[0] == '#');    //Saute les titres
    Efface_n(ligne);      //Retire le \n
    fclose(temp);
    return ligne;
}
