/* Programme de jet d'attaque pour donjons et dragons 3.5.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 3.0. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include "Utilitaire.h"
#include "Rand.h"
#include "Jdr.h"

int interpret_attaque(char *attaque, int *bonus_att); /*Interprete les bonus d'attaques, et stocke les diffrents bonus dans le tableau, renvoi le nombre de jets*/

int main (int argc,char *argv[])
{
    int CA, jet_att, loc, nb_attac, i;
    int bonus_att[10];
    char attaque[50];
    Init_srand();
    init_historique_saisie();
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre (argc,argv,"Attaque","Module d'attaque de Donjons et dragons 3.5",color_sd("Attaque 3.5",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    do
    {
        printf("\nBonus d'attaque (Pas de calcul !): +");
        nb_attac = interpret_attaque(attaque,bonus_att);
        do
        {    /*Boucle d'erreur de saisie*/
            printf("CA de l'adversaire: ");
            CA = (int) interpret_calc("\0");
        } while (CA == NA || CA == defo);
        for (i=0;i<nb_attac;i++)
        {
            jet_att = NbAlea1b(20);   /*Effectue le jet de d20 du jet d'attaque*/
            if (jet_att > 1)  /*Si c'est pas un critique*/
            {
                printf("\nJet naturel= %d\n", jet_att);
                printf("Confirmation critique: ");
                if (NbAlea1b(20) + bonus_att[i] < CA)
                    printf("non\n");
                else
                    printf("OK !\n");
                printf("%s %d\n", acc("Jet modifi=",chfunc), jet_att+bonus_att[i]);
                if (jet_att+bonus_att[i] < CA)
                {
                    putsacc("\nL'attaque a rate l'adversaire");
                }
                else
                {
                    putsacc("***** Attaque russie, l'adversaire est bless *****\n");
                    loc = NbAlea1b(20);   /*Jet de lacalisation*/
                    printf("Localisation de l'impact: %d  (pour un %s: ", loc, acc("humanode",chfunc));
                    if (loc <= 5)        /*Localisation humanode*/
                        puts("Jambes)\n");
                    if (loc >= 6 && loc <= 12)
                        puts("Torse)\n");
                    if (loc >= 13 && loc <= 15)
                        puts("Bras gauche)\n");
                    if (loc >= 16 && loc <= 18)
                        puts("Bras droit)\n");
                    if (loc == 19 || loc == 20)
                        putsacc("Tte (partie sensible!))\n");
                }
            }
            else
                printf("!!!!!! Echec critique !!!!!!        Jet critique= %d\n", NbAlea1b(20));
            Pause();
        }
    } while(1); /*Boucle infinie*/
    return 0;
}

int interpret_attaque(char *attaque, int *bonus_att)
{
    int i, j;
    strcpy(attaque,nomajloc_attaque(chfunc));
    i=0;
    for(j=0;j<10;j++)
    {
        if (attaque[0] == '-')        /*Si la valeur est ngative*/
        {
            Efface_char(attaque,"-");
            bonus_att[i++] = atoi(attaque) * -1;     /*Lit le bonus d'attaque et le stocke dans le tableau*/
        }
        else
            bonus_att[i++] = atoi(attaque);     /*Lit le bonus d'attaque et le stocke dans le tableau*/
        if (strstr(attaque,"/") == NULL && strstr(attaque,"\\") == NULL)    /*Si il n'y  plus d'attaque*/
            return i;       /*Renvoi le nombre d'attaque*/
        if (strstr(attaque,"/") != NULL)
            Efface_char(attaque,"/");   /*Se prpare  saisir la prochaine attaque*/
        else if (strstr(attaque,"\\") != NULL)
            Efface_char(attaque,"\\");   /*Se prpare  saisir le prochaine attaque*/
        if (attaque[0] == '+')        /*Si l'utilisateur  mis +*/
            Efface_char(attaque,"+");
    }
    return i;
}
