/* Programme de jets d'attaque multiple pour donjons et dragons 3.5.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.1. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include "Utilitaire.h"
#include "Rand.h"
#include "Jdr.h"

int main (int argc,char *argv[])
{
    int bonus_att, CA, jet_att, *loc, nb_attac, *critic, i, niv_critic, temp;
    Init_srand();
    init_historique_saisie();
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre (argc,argv,"Attaques multiples","Module d'attaques multiples de Donjons et dragons 3.5",color_sd("Attaques multiples 3.5",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    do
    {
        do
        {    /*bcl d'erreur de saisie*/
            putsacc("Nombre d'attaques  effectuer: ");
            nb_attac = (int) interpret_calc("\0");
        } while (nb_attac == NA || nb_attac == defo);
        puts("");
        do
        {    /*bcl d'erreur de saisie*/
            printf("Bonus d'attaque: +");
            bonus_att = (int) interpret_calc("\0");
        } while (bonus_att == NA || bonus_att == defo);
        do
        {    /*bcl d'erreur de saisie*/
            printf("CA: ");
            CA = (int) interpret_calc("\0");
        } while (CA == NA || CA == defo);
        do
        {    /*bcl d'erreur de saisie*/
            printf("Critique (20): ");
            niv_critic = (int) interpret_calc("\0");
            if (niv_critic == defo)    /*par defaut, le critique est fix  20*/
                niv_critic = 20;
        } while (niv_critic == NA);
        ER = (int) (loc = (int*) calloc(nb_attac,sizeof(int)));   /*Taille tableau = nb d'attaque*/
        Erreur(1);
        ER = (int) (critic = (int*) calloc(nb_attac,sizeof(int)));
        Erreur(1);
        for (i=0;i<nb_attac;i++)    /*Boucle sur le nombre d'attaque*/
        {
            jet_att = NbAlea1b(20);    /*Effectue le jet d'attaque*/
            printf("Attaque %d: %d,%d", i+1, jet_att, jet_att+bonus_att);/*Affiche le numro de l'attaque, le jet naturel et modifi*/
            if (jet_att == 1)
            {
                critic[i] = -1*NbAlea1b(20);  /*Echec critique not en valeur ngative*/
                printf("     ! Echec critique ! (%d).\n", -1*critic[i]);
                continue;    /*Reboucle sur le nombre d'attaque*/
            }
            if (jet_att >= niv_critic)
            {        /*Possibilit de critique*/
                temp = NbAlea1b(20)+bonus_att;    /*Reutilise variable resist pour confirmation du critic*/
                if (temp >= CA)
                {
                    critic[i] = 1;     /*Critique confirm not par 1*/
                    printf(":%d     Attaque critique\n", temp);
                    continue;  /*Reboucle sur le nombre d'attaque*/
                }
            }
            if (jet_att+bonus_att >= CA)
            {
                putsacc("     Adversaire touch.\n");
                loc[i] = NbAlea1b(20);    /*Localisation (signifie aussi attaque touche*/
            }
            else
                putsacc("     Attaque rate...\n");
        }
        Pause();
        printf("\n\nBilan des %d attaques:\n",nb_attac);
        for (i=0;i<nb_attac;i++)    /*Bcl sur nb d'attaque pour bilan des attaques russie*/
        {
            if (loc[i] || critic[i])    /*Si attaque russie ou critique*/
            {
                printf("Attaque %d: ", i+1);
                if (critic[i] == 1)
                {            /*Attaque critique, + localisation*/
                    printf("!!! Attaque critique ");
                    loc[i] = NbAlea1b(20);
                }
                if (critic[i] < 0)
                {            /*Echec critique, affiche le jet de critic*/
                    printf("!!! Echec critique, %d\n", -1*critic[i]);
                    continue;    /*Rebcl, ignorant la localisation*/
                }
                else
                    printf("touche ");   /*Sinon attaque russie simplement*/
                if (loc[i] <= 5)       /*Localisation humanode*/
                    printf("au jambes (%d)\n",loc[i]);
                if (loc[i] >= 6 && loc[i] <= 12)
                    printf("au torse (%d)\n",loc[i]);
                if (loc[i] >= 13 && loc[i] <= 15)
                    printf("au bras gauche (%d)\n",loc[i]);
                if (loc[i] >= 16 && loc[i] <= 18)
                    printf("au bras droit (%d)\n",loc[i]);
                if (loc[i] == 19 || loc[i] == 20)
                    printf("%s (%d)\n", acc(" la tte (partie sensible!)",chfunc), loc[i]);
            }
        }
        puts("");
        free(critic);
        free(loc);
    }while(1);
    return 0;
}
