/* Programme de jet d'initiative pour donjons et dragons 3.5 modifi.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.0. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include "Utilitaire.h"
#include "Rand.h"
#include "Jdr.h"

void tri_int_double (int *tab1, int *tab2, int taille); /*Tri un tableau  2 lignes, du plus grand au plus petit*/

int main (int argc,char *argv[])
{
    int *init, *creature, nb, bonus, taille=50, i=0, j=0;
    Init_srand();
    init_historique_saisie();
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre(argc,argv,"Initiative","Module de jets d'initiative pour Donjons et dragons",color_sd("Initiative",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    ER = (int) (init = (int*) calloc (taille,sizeof(int)));
    Erreur(1);
    ER = (int) (creature = (int*) calloc (taille,sizeof(int)));
    Erreur(1);
    do
    {
        if (j == 'o' || j == 'O')
            getchar();        /*Absorbe l'entre en cas de nouveau jet*/
        do
        {
            putsacc("Nombre de jets d'initiative  effectuer: ");
            nb = (int) interpret_calc("\0");
        } while (nb == NA || nb == defo);
        do
        {
            printf("Modificateur d'initiative: ");
            bonus = (int) interpret_calc("\0");
        } while (bonus == NA || bonus == defo);
        if (i+nb > taille)
        {        /*Agrandit le tableau si il n'est pas asser grand*/
            taille += 50;
            ER = (int) (init = (int*) realloc (init,taille*sizeof(int)));
            Erreur(1);
            ER = (int) (creature = (int*) realloc (creature,taille*sizeof(int)));
            Erreur(1);
        }
        for (j=0;j<nb;j++,i++)
        {        /*Effectue les jets d'init*/
            init[i] = NbAlea1b(20) + bonus;
            creature[i] = i+1;   /*Numrote chaque crature*/
        }
        for (j=i-nb;j<i;j++)       /*Affiche tous les rsultats*/
            printf("%d  ", init[j]);
        puts("");
        putsacc("\nEffectuer d'autres jets d'initiative (O/N, non par defaut): ");
        j = getchar();
        puts("");
    } while (j == 'o' || j == 'O');
    if (j != 10)
        getchar();
    tri_int_double (init,creature,i);
    for (j=0;j<i;j++)    /*Affiche les jets d'init tris*/
        printf("%s %d: %d\n", acc("Crature",chfunc), creature[j], init[j]);
    free(init);
    free(creature);
    Pause();
    return 0;
}

void tri_int_double (int *tab1, int *tab2, int taille)
{
    int i, tmp, borne;
    for (i=1,borne=0;i<taille;)
    {
        if (tab1[i] > tab1[i-1])
        {
            tmp = tab1[i-1];
            tab1[i-1] = tab1[i];
            tab1[i] = tmp;
            tmp = tab2[i-1];
            tab2[i-1] = tab2[i];
            tab2[i] = tmp;
            if (borne == 0)
                borne = i;
            if (i > 1)
                i--;
        }
        else
        {
            if (borne == 0)
                i++;
            else
            {
                i = borne + 1;
                borne = 0;
            }
        }
    }
}
