/* Programme de simulation de ds.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.1. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include "Rand.h"
#include "Utilitaire.h"
#include "Jdr.h"

int main (int argc,char *argv[])
{
    int total, val, i, *des;
    char chaine_des[255];
    FILE* sortie;
    Init_srand();
    init_historique_saisie();
    affichage_arg = 1;  //Affichage complet par defaut
    chaine_des[0] = '0';    //Par defaut, demande de saisie par l'utilisateur
    if(argc == 3)
    {
        Efface_char(argv[2],"=");
        affichage_arg = atoi(argv[2]);   /*Type d'affichage*/
    }
    if(affichage_arg == 1)
    {
        #ifdef WIN32    /*win*/
            Ph_jdr("..\\Phrases de jdr.txt");
        #endif
        Titre (argc,argv,"Ds","Module de simulation de ds",color_sd("Des",chfunc,argv));
        #ifndef WIN32    /*linux*/
            Ph_jdr("..\\Phrases de jdr.txt");
        #endif
    }
    if(argc>1)
    {   /*Si arguments*/
        if(argc != 3)
        {
            #ifdef WIN32    /*win*/
                system("color FC");
            #endif
            putsacc("Erreur lors de l'excution de Simulateur_ds.exe, nombre d'arguments incorrect !");
            Pause();
            exit(0);
        }
        Efface_char(argv[1],"=");
        strcpy(chaine_des,argv[1]);   /*Ds  tirer*/
    }
    do
    {
        total=0;
        if(argc == 1)   //Si pas d'arguments
            putsacc("Type de ds (.d.): ");
        des = interpret_des(des,chaine_des,chfunc);
        if(affichage_arg == 1)
            puts("");
        sortie = ouvre_fichier("Sortie simul_des.txt","w");
        for (i=1;i<des[0];i++)    /*Bcl sur le nombre de ds  lancer - 1*/
        {
            val = NbAlea1b(des[i]);
            if(affichage_arg < 3)
                printf("%d, ", val);
            fprintf(sortie,"%d, ", val);
            total += val;
        }
        val = NbAlea1b(des[i]);        /*Lance le dernier d (pour terminer l'affichage)*/
        if(affichage_arg < 3)
            printf("%d.\n", val);        /*Termine l'affichage*/
        fprintf(sortie,"%d.\n", val);
        total += val;
        if(affichage_arg < 3)
            printf("\nTotal= %d.\n", total);    /*Affiche le total  des valeur ajoute*/
        fprintf(sortie,"\nTotal= %d.\n", total);
        free(des);
        fclose(sortie);
        if(argc>1)  //Si arguments, boucle une seule fois
            break;
    } while(1); /*Boucle infinie*/
    return 0;
}
