/* Programme de conversion de personnage par le menu contextuel pour donjons et dragons 3.5.
Programm par Maniack Crudelis.
http://www.crudelis.rf.lv
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 1.1*/
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Fichier.h"
#include "Utilitaire.h"
#include "Jdr.h"
#include "Chaines.h"

int main (int argc,char *argv[])
{
    FILE* temp_file;
    FILE* Fichier_txtp;
    FILE* Fichier_html;
    char chaine[255];
    char chaine2[255];
    char* nomfichier=NULL;
    int i,type;
    Titre (argc,argv,"Conversion de personnages","Programme de conversion de personnages html en txtp pour Donjons et dragons","0F");
    if(argc==1)
    {   /*Le programme n'a pas en argument le nom du fichier, lancement du programme seul*/
        putsacc("Entrez le nom complet du fichier html  convertir en txtp\n?: ");
        nomfichier = getsdyn(nomfichier);
    }
    else
    {   /*Le programme est lanc avec l'argument (clic droit)*/
        ER = (int) (nomfichier = (char*) calloc(strlen(argv[1])*2,sizeof(char)));
        Erreur(1);
        strcpy(nomfichier,argv[1]);
    }
    putsacc(nomfichier);
    puts("");
    puts("");
    Fichier_html = ouvre_fichier(nomfichier,"r");
    nomfichier[strlen(nomfichier)-4] = '\0';
    strcat(nomfichier,"txtp"); /*nomfichier pret pour cration du fichier txtp*/
    temp_file = ouvre_fichier("tempfile.tmp","w");
    /*Dbut de ramplissage du fichier temp en fonction du fichier html*/
    for(i=0;i<12;i++)
        fgets(chaine,255,Fichier_html); /*Nom*/
    fprintf(temp_file,"..Nom:%s", chaine);
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*Classe*/
    fprintf(temp_file,"..Classe:%s", chaine);
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*Race*/
    fprintf(temp_file,"..Race:%s", chaine);
    for(i=0;i<2;i++)
        fgets(chaine,255,Fichier_html); /*Sexe*/
    fprintf(temp_file,"..Sexe:%s", chaine);
    for(i=0;i<2;i++)
        fgets(chaine,255,Fichier_html); /*Poids*/
    fprintf(temp_file,"..Poids:%s", chaine);
    for(i=0;i<2;i++)
        fgets(chaine,255,Fichier_html); /*Taille*/
    fprintf(temp_file,"..Taille:%s", chaine);
    for(i=0;i<2;i++)
        fgets(chaine,255,Fichier_html); /*Age*/
    fprintf(temp_file,"..Age:%s", chaine);
    for(i=0;i<2;i++)
        fgets(chaine,255,Fichier_html); /*Traits physiques*/
    while (strstr(chaine,"</div>") == NULL) /*Parcours tous les traits physiques*/
    {
        fgets(chaine,255,Fichier_html);
        if(strstr(chaine,"</div>") != NULL)
            break;
        fprintf(temp_file,"..#tp:%s", chaine); /*Recopie les traits physiques*/
        for(i=0;i<1;i++)
            fgets(chaine,255,Fichier_html);
    }
    for(i=0;i<2;i++)
        fgets(chaine,255,Fichier_html); /*Alignement*/
    fprintf(temp_file,"..Alignement:%s", chaine);
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*Force*/
    fprintf(temp_file,"..Force:%s", chaine);
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*Dex*/
    fprintf(temp_file,"..Dextrit:%s", chaine);
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*Con*/
    fprintf(temp_file,"..Constitution:%s", chaine);
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*Int*/
    fprintf(temp_file,"..Intelligence:%s", chaine);
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*Sag*/
    fprintf(temp_file,"..Sagesse:%s", chaine);
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*Cha*/
    fprintf(temp_file,"..Charisme:%s", chaine);
    for(i=0;i<5;i++)
        fgets(chaine,255,Fichier_html); /*Langues*/
    while (strstr(chaine,"</div>") == NULL) /*Parcours toutes les langues*/
    {
        fgets(chaine,255,Fichier_html);
        if(strstr(chaine,"</div>") != NULL)
            break;
        fprintf(temp_file,"..#lg:%s", chaine); /*Recopie les langues*/
        for(i=0;i<1;i++)
            fgets(chaine,255,Fichier_html);
    }
    for(i=0;i<2;i++)
        fgets(chaine,255,Fichier_html); /*Vision*/
    fprintf(temp_file,"..%s", chaine);
    for(i=0;i<2;i++)
        fgets(chaine,255,Fichier_html); /*Capacits spciales*/
    while (strstr(chaine,"</div>") == NULL) /*Parcours toutes les capacits spciales*/
    {
        fgets(chaine,255,Fichier_html);
        if(strstr(chaine,"</div>") != NULL)
            break;
        fprintf(temp_file,"..#cs:%s", chaine); /*Recopie les capacits spciales*/
        for(i=0;i<1;i++)
            fgets(chaine,255,Fichier_html);
    }
    i=1; /*XP ok*/
    while(strstr(chaine,"<p align=\"center\"><strong>XP: </strong>") == NULL)
    {    /*Recherche de la ligne correspondante*/
        if (fgets(chaine,255,Fichier_html) == NULL)
        {
            i=0; /*XP n'est pas trouv*/
            rewind(Fichier_html);
            break;  /*La ligne n'est pas trouve. Pas d'affichage d'XP*/
        }
    }
    if(i==1)
    {   /*Relve l'XP, seulement si il existe*/
        fgets(chaine,255,Fichier_html); /*XP*/
        fprintf(temp_file,"..XP:%s", chaine);
    }
    i=1; /*Armure ok*/
    while(strstr(chaine,"<div align=\"center\"><strong>Armure: </strong>") == NULL)
    {    /*Recherche de la ligne correspondante*/
        if (fgets(chaine,255,Fichier_html) == NULL)
        {
            i=0; /*Armure n'est pas trouv*/
            rewind(Fichier_html);
            break;  /*La ligne n'est pas trouve. Pas d'affichage d'armure*/
        }
    }
    if(i==1)
    {   /*Relve l'armure, seulement si elle existe*/
        fgets(chaine,255,Fichier_html); /*Armure*/
        fprintf(temp_file,"..Armure:%s", chaine);
    }
    i=1; /*Bouclier ok*/
    while(strstr(chaine,"<div align=\"center\"><strong>Bouclier: </strong>") == NULL)
    {    /*Recherche de la ligne correspondante*/
        if (fgets(chaine,255,Fichier_html) == NULL)
        {
            i=0; /*Bouclier n'est pas trouv*/
            rewind(Fichier_html);
            break;  /*La ligne n'est pas trouve. Pas d'affichage de bouclier*/
        }
    }
    if(i==1)
    {   /*Relve le bouclier, seulement si il existe*/
        fgets(chaine,255,Fichier_html); /*Bouclier*/
        fprintf(temp_file,"..Bouclier:%s", chaine);
    }
    i=1; /*Arme principale ok*/
    while(strstr(chaine,"<div align=\"center\"><strong>Arme primaire: </strong>") == NULL)
    {    /*Recherche de la ligne correspondante*/
        if (fgets(chaine,255,Fichier_html) == NULL)
        {
            i=0; /*Arme principale n'est pas trouv*/
            rewind(Fichier_html);
            break;  /*La ligne n'est pas trouve. Pas d'affichage d'arme principale*/
        }
    }
    if(i==1)
    {   /*Relve l'arme principale, seulement si elle existe*/
        fgets(chaine,255,Fichier_html); /*Arme 1*/
        fprintf(temp_file,"..Arme principale:%s", chaine);
    }
    i=1; /*Arme secondaire ok*/
    while(strstr(chaine,"<div align=\"center\"><strong>Arme secondaire: </strong>") == NULL)
    {    /*Recherche de la ligne correspondante*/
        if (fgets(chaine,255,Fichier_html) == NULL)
        {
            i=0; /*Arme secondaire n'est pas trouv*/
            rewind(Fichier_html);
            break;  /*La ligne n'est pas trouve. Pas d'affichage d'arme secondaire*/
        }
    }
    if(i==1)
    {   /*Relve l'arme secondaire, seulement si elle existe*/
        fgets(chaine,255,Fichier_html); /*Arme 2*/
        fprintf(temp_file,"..Arme secondaire:%s", chaine);
    }
    i=1; /*Arme tertiaire ok*/
    while(strstr(chaine,"<div align=\"center\"><strong>Arme tertiaire: </strong>") == NULL)
    {    /*Recherche de la ligne correspondante*/
        if (fgets(chaine,255,Fichier_html) == NULL)
        {
            i=0; /*Arme tertiaire n'est pas trouv*/
            rewind(Fichier_html);
            break;  /*La ligne n'est pas trouve. Pas d'affichage d'arme tertiaire*/
        }
    }
    if(i==1)
    {   /*Relve l'arme tertiaire, seulement si elle existe*/
        fgets(chaine,255,Fichier_html); /*Arme 3*/
        fprintf(temp_file,"..Arme tertiaire:%s", chaine);
    }
    i=1; /*Attaque secondaire ok*/
    while(strstr(chaine,"<div align=\"center\"><strong>Attaque secondaire: </strong>") == NULL)
    {    /*Recherche de la ligne correspondante*/
        if (fgets(chaine,255,Fichier_html) == NULL)
        {
            i=0; /*Attaque secondaire n'est pas trouv*/
            rewind(Fichier_html);
            break;  /*La ligne n'est pas trouve. Pas d'affichage d'attaque secondaire*/
        }
    }
    if(i==1)
    {   /*Relve l'attaque secondaire, seulement si elle existe*/
        do
        {
            fgets(chaine,255,Fichier_html); /*Attaque secondaire*/
            fprintf(temp_file,"..Attaque secondaire:%s", chaine);
            fgets(chaine,255,Fichier_html);
            fgets(chaine,255,Fichier_html);
        }while(strstr(chaine,"<div align=\"center\"><strong>Attaque secondaire: </strong>"));   //Bcl tant qu'il y a des attaques secondaires
    }
    while(strstr(chaine,"<p align=\"center\"><strong><font size=\"6\">Niveau: ") == NULL)
        fgets(chaine,255,Fichier_html);    /*Recherche de la ligne du niveau*/
    fgets(chaine,255,Fichier_html); /*Niveau*/
    fprintf(temp_file,"..Niveau:%s", chaine);
    for(i=0;i<5;i++)
        fgets(chaine,255,Fichier_html); /*PV*/
    fprintf(temp_file,"..Points de vie:%s", chaine);
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*Jet d'attaque*/
    fprintf(temp_file,"..Jet d'attaque:%s", chaine);
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*JS rf*/
    fprintf(temp_file,"..JS rflexe:%s", chaine);
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*JS vig*/
    fprintf(temp_file,"..JS vigueur:%s", chaine);
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*JS vol*/
    fprintf(temp_file,"..JS volont:%s", chaine);
    for(i=0;i<4;i++)
        fgets(chaine,255,Fichier_html); /*Dons*/
    while (strstr(chaine,"</div>") == NULL) /*Parcours tous les dons*/
    {
        fgets(chaine,255,Fichier_html);
        if(strstr(chaine,"</div>") != NULL)
            break;
        fprintf(temp_file,"..#don:%s", chaine); /*Recopie les dons*/
        for(i=0;i<1;i++)
            fgets(chaine,255,Fichier_html);
    }
    for(i=0;i<4;i++)
        fgets(chaine,255,Fichier_html); /*Comptences*/
    while (strstr(chaine,"</div>") == NULL) /*Parcours toutes les comptences*/
    {
        fgets(chaine,255,Fichier_html);
        if(strstr(chaine,"</div>") != NULL)
            break;
        fprintf(temp_file,"..#comp:%s", chaine); /*Recopie les comptences*/
        for(i=0;i<1;i++)
            fgets(chaine,255,Fichier_html);
    }
    for(i=0;i<3;i++)
        fgets(chaine,255,Fichier_html); /*Equipement*/
    while (strstr(chaine,"</div>") == NULL) /*Parcours tout l'quipement*/
    {
        fgets(chaine,255,Fichier_html);
        if(strstr(chaine,"</div>") != NULL)
            break;
        fprintf(temp_file,"..#equ:%s", chaine); /*Recopie l'quipement*/
        for(i=0;i<1;i++)
            fgets(chaine,255,Fichier_html);
    }
    i=1; /*nb objets magiques ok*/
    while(strstr(chaine," objets magiques  dterminer.") == NULL)
    {    /*Recherche de la ligne correspondante*/
        if (fgets(chaine,255,Fichier_html) == NULL)
        {
            i=0; /*nb objets magiques n'est pas trouv*/
            rewind(Fichier_html);
            break;  /*La ligne n'est pas trouve. Pas d'affichage du nb objets magiques*/
        }
    }
    if(i==1)
        fprintf(temp_file,"%s", chaine);   /*Relve le nb objets magiques, seulement si il existe*/
    fclose(Fichier_html);
    fclose(temp_file);
    /*Dbut de cration du fichier txtp en fonction du fichier temp*/
    Fichier_txtp = ouvre_fichier(nomfichier,"w");
    temp_file = ouvre_fichier("tempfile.tmp","r");
    for(i=1;i<36;i++)
    {
        switch (i)
        {
            case 1: /*Classe de personnage*/
                strcpy(chaine2,"..Nom:");
                type=1; /*indique que c'est une ligne seule*/
                fprintf(Fichier_txtp,"Nom: ");
                break;
            case 2: /*Classe de personnage*/
                strcpy(chaine2,"..Classe:");
                type=1; /*indique que c'est une ligne seule*/
                fprintf(Fichier_txtp,"Classe de personnage: ");
                break;
            case 3: /*Niveau*/
                strcpy(chaine2,"..Niveau:");
                type=1;
                fprintf(Fichier_txtp,"Niveau: ");
                break;
            case 4: /*Race*/
                strcpy(chaine2,"..Race:");
                type=1;
                fprintf(Fichier_txtp,"Traits physiques:\n Race: ");
                break;
            case 5: /*Sexe*/
                strcpy(chaine2,"..Sexe:");
                type=1;
                fprintf(Fichier_txtp," Sexe: ");
                break;
            case 6: /*Poids*/
                strcpy(chaine2,"..Poids:");
                type=1;
                fprintf(Fichier_txtp," Poids: ");
                break;
            case 7: /*Taille*/
                strcpy(chaine2,"..Taille:");
                type=1;
                fprintf(Fichier_txtp," Taille: ");
                break;
            case 8: /*Age*/
                strcpy(chaine2,"..Age:");
                type=1;
                fprintf(Fichier_txtp," Age: ");
                break;
            case 9: /*Traits physiques*/
                strcpy(chaine2,"..#tp:");
                type=3; /*indique que c'est une liste de ligne dont la taille n'est pas fixe*/
                break;
            case 10: /*Force*/
                strcpy(chaine2,"..Force:");
                type=1;
                fprintf(Fichier_txtp,"Caractristiques:\nForce: ");
                break;
            case 11: /*Dextrit*/
                strcpy(chaine2,"..Dextrit:");
                type=1;
                fprintf(Fichier_txtp,"Dextrit: ");
                break;
            case 12: /*Constitution*/
                strcpy(chaine2,"..Constitution:");
                type=1;
                fprintf(Fichier_txtp,"Constitution: ");
                break;
            case 13: /*Intelligence*/
                strcpy(chaine2,"..Intelligence:");
                type=1;
                fprintf(Fichier_txtp,"Intelligence: ");
                break;
            case 14: /*Sagesse*/
                strcpy(chaine2,"..Sagesse:");
                type=1;
                fprintf(Fichier_txtp,"Sagesse: ");
                break;
            case 15: /*Charisme*/
                strcpy(chaine2,"..Charisme:");
                type=1;
                fprintf(Fichier_txtp,"Charisme: ");
                break;
            case 16: /*Vision*/
                strcpy(chaine2,"..Vision");
                type=1;
                break;
            case 17: /*Alignement*/
                strcpy(chaine2,"..Alignement:");
                type=1;
                fprintf(Fichier_txtp,"Alignement: ");
                break;
            case 18: /*Jet d'attaque*/
                strcpy(chaine2,"..Jet d'attaque:");
                type=1;
                fprintf(Fichier_txtp,"Jet d'attaque: ");
                break;
            case 19: /*JS Rflexe*/
                strcpy(chaine2,"..JS rflexe:");
                type=1;
                fprintf(Fichier_txtp,"Jet de sauvegarde:\n Rflexe: ");
                break;
            case 20: /*JS Vigueur*/
                strcpy(chaine2,"..JS vigueur:");
                type=1;
                fprintf(Fichier_txtp," Vigueur: ");
                break;
            case 21: /*JS Volont*/
                strcpy(chaine2,"..JS volont:");
                type=1;
                fprintf(Fichier_txtp," Volont: ");
                break;
            case 22: /*Points de vie*/
                strcpy(chaine2,"..Points de vie:");
                type=1;
                fprintf(Fichier_txtp,"Points de vie: ");
                break;
            case 23: /*Armure*/
                strcpy(chaine2,"..Armure:");
                type=2; /*indique que c'est une ligne seule, mais dont la prsence doit tre vrifie*/
                break;
            case 24: /*Arme principale*/
                strcpy(chaine2,"..Arme principale:");
                type=2;
                break;
            case 25: /*Arme secondaire*/
                strcpy(chaine2,"..Arme secondaire:");
                type=2;
                break;
            case 26: /*Arme tertiaire*/
                strcpy(chaine2,"..Arme tertiaire:");
                type=2;
                break;
            case 27: /*..Attaque secondaire*/
                strcpy(chaine2,"..Attaque secondaire:");
                type=4;
                break;
            case 28: /*Bouclier*/
                strcpy(chaine2,"..Bouclier:");
                type=2;
                break;
            case 29: /*Langues parles*/
                strcpy(chaine2,"..#lg:");
                type=3;
                fprintf(Fichier_txtp,"Langues parles:\n");
                break;
            case 30: /*Dons*/
                strcpy(chaine2,"..#don:");
                type=3;
                fprintf(Fichier_txtp,"Dons:\n");
                break;
            case 31: /*Comptences*/
                strcpy(chaine2,"..#comp:");
                type=3;
                fprintf(Fichier_txtp,"Comptences:\n");
                break;
            case 32: /*objets magiques  dterminer*/
                strcpy(chaine2," objets magiques  dterminer.");
                type=2;
                break;
            case 33: /*Points d'exprience*/
                strcpy(chaine2,"..XP:");
                type=2;
                break;
            case 34: /*Capacits spciales*/
                strcpy(chaine2,"..#cs:");
                type=3;
                fprintf(Fichier_txtp,"Capacits spciales:\n");
                break;
            case 35: /*Equipements*/
                strcpy(chaine2,"..#equ:");
                type=3;
                fprintf(Fichier_txtp,"#Equipements:\n");
                break;
        }
        rewind(temp_file); /*Reviens au dbut du fichier temp*/
        switch (type)
        {
            case 1: /*Ligne seule*/
                do
                {
                    fgets(chaine,255,temp_file);
                }while(strstr(chaine,chaine2) == NULL);    /*Cherche la ligne indiqu par le switch case i*/
                if(strcmp(chaine2,"..Vision")!=0)
                    Efface_char(chaine,":"); /*Retire l'indication en dbut de ligne (seulement si c'est pas vision ou nb objets magiques qui n'ont pas de :)*/
                if(strcmp(chaine2,"..Vision")==0)
                {
                    Efface_char(chaine,".."); /*Retire le . devant vision*/
                }
                fprintf(Fichier_txtp,"%s",chaine); /*Ecrit la valeur  la suite dans le fichier txtp*/
                break;
            case 2: /*Ligne seule, mais dont la prsence doit tre vrifie*/
                while(strstr(chaine,chaine2) == NULL)
                {    /*Recherche de la ligne correspondante*/
                    if (fgets(chaine,255,temp_file) == NULL)
                    {
                        type=0; /*Si la ligne n'existe pas*/
                        break;
                    }
                }
                if(type!=0) /*Si la ligne existe, effectue son affichage*/
                {
                    if(strcmp(chaine2,"..Armure:")==0)
                        fprintf(Fichier_txtp,"Armure: ");
                    if(strcmp(chaine2,"..Arme principale:")==0)
                        fprintf(Fichier_txtp,"Arme principale: ");
                    if(strcmp(chaine2,"..Arme secondaire:")==0)
                        fprintf(Fichier_txtp,"Arme secondaire: ");
                    if(strcmp(chaine2,"..Arme tertiaire:")==0)
                        fprintf(Fichier_txtp,"Arme tertiaire: ");
                    if(strcmp(chaine2,"..Bouclier:")==0)
                        fprintf(Fichier_txtp,"Bouclier: ");
                    if(strcmp(chaine2,"..XP:")==0)
                        fprintf(Fichier_txtp,"Points d'exprience: ");
                    if(strcmp(chaine2," objets magiques  dterminer.")!=0)
                        Efface_char(chaine,":"); /*Retire l'indication en dbut de ligne*/
                    fprintf(Fichier_txtp,"%s",chaine); /*Ecrit la valeur  la suite dans le fichier txtp*/
                }
                break;
            case 3: /*Liste de ligne dont la taille n'est pas fixe*/
                do
                {
                    fgets(chaine,255,temp_file);
                }while(strstr(chaine,chaine2) == NULL);    /*Cherche le dbut de la liste indiqu par le switch case i*/
                while(strstr(chaine,chaine2) != NULL)    /*Tant qu'il reste des lignes  afficher dans la liste*/
                {
                    Efface_char(chaine,":"); /*Retire l'indication en dbut de ligne*/
                    fprintf(Fichier_txtp,"%s",chaine); /*Ecrit la valeur  la suite dans le fichier txtp*/
                    fgets(chaine,255,temp_file);
                };
                fprintf(Fichier_txtp,">\n");
                break;
            case 4:     //Pour Attaque secondaire, plusieurs attaques secondaires possible. Ligne seule dont la prsence doit tre vrifie
                while(strstr(chaine,"..Attaque secondaire:") == NULL)
                {    /*Recherche de la ligne correspondante*/
                    if (fgets(chaine,255,temp_file) == NULL)
                    {
                        type=0; /*Si la ligne n'existe pas*/
                        break;
                    }
                }
                if(type!=0) /*Si la ligne existe, effectue son affichage*/
                {
                    do
                    {
                        Efface_char(chaine,":"); /*Retire l'indication en dbut de ligne*/
                        fprintf(Fichier_txtp,"Attaque secondaire: %s", chaine); /*Ecrit la valeur  la suite dans le fichier txtp*/
                        fgets(chaine,255,temp_file);
                    }while(strstr(chaine,"..Attaque secondaire:") != NULL);
                }
                break;
        }
    }
    fclose(Fichier_txtp);
    fclose(temp_file);
    free(nomfichier);
    return 0;
}
