#/bin/bash

cible_kde="$HOME/.kde/share/kde4/services/ServiceMenus/"
cible_gnome="$HOME/.gnome2/nautilus-scripts/Servus Domini/"
# KDE
if [ -d $HOME/.kde/share/kde4/services/ ]; then
  echo "Dossiers de KDE trouvés"
  rm -f "$cible_kde/Conv_txthtml.desktop"
  echo "Conv_txthtml.desktop supprimé"
  rm -f "$cible_kde/Conv_htmltxtp.desktop"
  echo "Conv_htmltxtp.desktop supprimé"
  rm -f "$cible_kde/Testeur_table.desktop"
  echo "Testeur_table.desktop supprimé"
else
 echo "Dossiers de KDE non trouvés."
fi

# GNOME
if [ -d $HOME/.gnome2/ ]; then
  echo "Dossiers de gnome trouvés"
  rm -f "$cible_gnome/Conv_txthtml.sh"
  echo "Conv_txthtml.sh supprimé"
  rm -f "$cible_gnome/Conv_htmltxtp.sh"
  echo "Conv_htmltxtp.sh supprimé"
  rm -f "$cible_gnome/Testeur_table.sh"
  echo "Testeur_table.sh supprimé"
  rmdir "$HOME/.gnome2/nautilus-scripts/Servus Domini"
else
 echo "Dossiers de gnome non trouvés."
fi

#MIME
echo "Suppression du type mime text/tbl"
rm -f "$HOME/.local/share/mime/packages/tbl.xml"
echo "Suppression du type mime text/txtp"
rm -f "$HOME/.local/share/mime/packages/txtp.xml"
echo "Mise à jour de la base de donnée mime"
update-mime-database ~/.local/share/mime
echo "Fin du nettoyage de l'intégration au menu contextuel"
