/* Programme de d'aide  la cration de personnages pour donjons et dragons 3.5.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 5.3. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "Fichier.h"
#include "Rand.h"
#include "Menu.h"
#include "Utilitaire.h"
#include "Jdr.h"
#include "Tri.h"

void pds_tail_age ();       /*Dtermine le poids, la taille et l'ge en fonction de la classe, la race et le sexe*/
void carac ();     /*Tire des carac*/
void niveau ();  /*dtermine alatoirement le niveau*/
void Trait_physique ();     /*Dtermine les traits physiques d'un personnage*/
void stades_blessures ();   /*Dtermine simplement les stades de blessures selon les PV*/
void calcul_IMC();  //Calcul l'IMC d'un personnage en fonction de sa race et de son sexe

int verif_val_gen_alea (int* index, char* ligne, int alea);  /*gen_alea, dtermine si la ligne actuelle est celle correspondant au jet de d*/
int jet_de_des_gen_alea (int* index, char* ligne);       /*gen_alea, Determine si un d doit tre lanc, et le lance le cas chant. Renvoi le jet ou 0 si aucun jet ne doit tre effectu*/
char* string_gen_alea (int index, char* ligne); /*gen_alea, Affiche le rsultat*/

int main (int argc,char *argv[])
{
    Init_srand();   /*Init rand*/
    init_historique_saisie();
    int choix;
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre (argc,argv,"Aide cration de perso","Programme d'aide  la cration de personnages pour Donjons et dragons",color_sd("Aide creation de perso",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    putsacc("1) Dterminer le niveau d'un PNJ.\n");
    putsacc("2) Tirer les caractristiques d'un personnage.\n");
    putsacc("3) Dterminer le poids, la taille et l'ge.\n");
    putsacc("4) Dterminer les traits physiques.\n");
    putsacc("5) Calculer les stades de blessures.\n");
    putsacc("6) Dterminer l'indice de masse corporelle IMC.\n");
    do
    {
        printf("?: ");
        choix = chiffre_lettre();   /*Prend la saisie de l'utilisateur*/
        if(choix == QUIT)
            exit(0);
        puts("");
        switch (choix)
        {        /*Choix du menu*/
            case 1:
                niveau();
                break;
            case 2:
                carac();
                break;
            case 3:
                pds_tail_age();
                break;
            case 4:
                Trait_physique();
                break;
            case 5:
                stades_blessures();
                break;
            case 6:
                calcul_IMC();
                break;
            default:
                Fuck();
                choix = 0;
        }
    } while (!choix);   /*Erreur de menu*/
    Pause();
    return 0;
}

void pds_tail_age ()
{
    FILE* fichier;
    float IMC;
    float IMCtab[6];
    float tailleM;
    char chaine[255];
    char classe[] = "#classe 0";
    char race[50];
    char sexe[10];
    int niveau, age, taille, poids;
    int base_age,nb_d_age,face_d_age,max_age,base_taille,nb_d_taille,face_d_taille,base_poids,nb_d_poids,face_d_poids, factpoi=0, facttail=0, i, j;
    fichier = ouvre_fichier("..\\Donnes\\Poids_taille_age.ini","r");
    do
    {
        strcpy(race,Menu("..\\Donnes\\Menu_race.ini",chfunc,1,0));
    }while(strstr(race,"Alea") != NULL);
    do
    {
        strcpy(sexe,Menu("..\\Donnes\\Menu_sexe.ini",chfunc,1,0));
    }while(strstr(sexe,"Alea") != NULL);
    strcpy(chaine,Menu("..\\Donnes\\Menu_type_classe.ini",chfunc,1,0));
    classe[8] = chaine[7];    /*Prend le numro du groupe de classe*/
    do
    {    /*Bcl erreur de saisie*/
        putsacc("\nNiveau du personnage: ");
        niveau = (int) interpret_calc("\0");
    } while (niveau == NA || niveau == defo);

    while (strstr(chaine,race) == NULL)
    {    /*Recherche la ligne de la race*/
        fgets(chaine,255,fichier);
    }
    while (strstr(chaine,sexe) == NULL)
    {    /*Recherche la ligne du sexe*/
        fgets(chaine,255,fichier);
    }
    while (strstr(chaine,classe) == NULL)
    {    /*Recherche la ligne de la classe*/
        fgets(chaine,255,fichier);
    }
    fgets(chaine,255,fichier);            /*Saisi la ligne contenant les donnes*/
    for (i=0;i<10;i++)
    {    /*Relve les 10 donnes*/
        Efface_char(chaine,"=");
        switch (i)
        {
            case 0:
                base_age = atoi(chaine);     /*Base age*/
                break;
            case 1:
                nb_d_age = atoi(chaine);     /*Nb de ds age*/
                break;
            case 2:
                face_d_age = atoi(chaine);   /*Nb de face du ds age*/
                break;
            case 3:
                max_age = atoi(chaine);   /*Age maximum*/
                break;
            case 4:
                base_taille = atoi(chaine);     /*Base taille*/
                break;
            case 5:
                nb_d_taille = atoi(chaine);     /*Nb de ds taille*/
                break;
            case 6:
                face_d_taille = atoi(chaine);   /*Nb de face du ds taille*/
                break;
            case 7:
                base_poids = atoi(chaine);     /*Base poids*/
                break;
            case 8:
                nb_d_poids = atoi(chaine);     /*Nb de ds taille*/
                break;
            case 9:
                face_d_poids = atoi(chaine);   /*Nb de face du ds poids*/
                break;
        }
    }
    /*Lit les 6 valeur d'IMC*/
    Efface_char(chaine,"=");
    IMCtab[0] = atof(chaine);
    for (i=1;i<6;i++)
    {
        Efface_char(chaine,",");
        IMCtab[i] = atof(chaine);
    }
    for (i=0;i<nb_d_age;i++)     /*Calcul de l'age*/
        base_age += NbAlea1b(face_d_age);
    age = base_age;
    if (niveau > 1)
    {   /*Si c'est un niveau 1 on garde uniquement la base*/
        age = NbAlea2b(base_age+niveau,max_age);  /*Dtermine un ge entre la base + le niveau et le maximum*/
        for(j=0;j<4;j++)
        {   /*Le jet prcdent sera donc effectu 5 fois*/
            i = NbAlea2b(base_age+niveau,max_age);  /*Dtermine un ge entre la base + le niveau et le maximum*/
            if(i < age)
                age = i;    /*On garde systmatiquement l'ge le plus jeune*/
        }
    }
    for (i=0;i<nb_d_taille;i++)  /*Calcul du facteur taille*/
        facttail += NbAlea1b(face_d_taille);
    taille = base_taille+facttail;    /*Calcul de la taille*/
    for (i=0;i<nb_d_poids;i++)    /*Calcul du facteur poids*/
        factpoi += NbAlea1b(face_d_poids);
    poids = base_poids+(facttail*factpoi/5);    /*Calcul du poids, en fonction de la taille*/
    printf("\nAge: %d ans.\n", age);
    printf("Taille: %d cm.\n", taille);
    printf("Poids: %d Kg.\n", poids);
    tailleM = (float) taille/100;
    IMC = (poids/(tailleM*tailleM));    /*IMC = poids/taille au carr. Taille divis par 100 pour avoir en mtre*/
    if(IMC < IMCtab[0])
        putsacc("Dnutrition");
    else if(IMC < IMCtab[1])
        printf("Maigreur");
    else if(IMC < IMCtab[2])
        printf("Corpulence normale");
    else if(IMC < IMCtab[3])
        printf("Surpoids");
    else if(IMC < IMCtab[4])
        putsacc("Obsit modre");
    else if(IMC < IMCtab[5])
        putsacc("Obsit svre");
    else   /*Suprieur ou gal  IMCtab[5]*/
        putsacc("Obsit massive");
}

void carac ()
{
    int jet_des[4];
    int tabcaractemp[6];
    int caracteristique[6];
    int i, j, total_temp, total, nb, nb_jet, min, index_min;
    for(i=0;i<6;i++)
        caracteristique[i] = 0;    /*Initialise le tableau gnral*/
    do
    {    /*Boucle d'erreur de saisie*/
        printf("Combien de jets voulez-vous effectuer? ");
        nb_jet = (int) interpret_calc("\0");
    } while (nb_jet == NA || nb_jet == defo);
    putsacc("\nLe total des caractristiques se trouve entre 75 et 90.\n");
    for (;nb_jet>0;nb_jet--)    /*Boucle sur le nombre de jet*/
    {
        total=0;
        for(i=0;i<6;i++)
            caracteristique[i] = 0;    /*Initialise le tableau principal entre chaque jet*/
        for (nb=0;nb<4;nb++)    /*Boucle sur le nombre de jet (4 jets, le plus lev est gard)*/
        {
            do    /*Relance tant que le jet n'est pas entre 75 et 90*/
            {
                for(i=0;i<6;i++)
                    tabcaractemp[i] = 0;    /*Initialise le tableau temporaire*/
                for(i=0,total_temp=0;i<6;i++)    /*6 carac*/
                {
                    for (j=0,min=6;j<4;j++)  /*Technique des 4 ds*/
                    {
                        jet_des[j] = NbAlea1b(6);
                        if (jet_des[j] < min)
                        {        /*Dtermine lequel des 4 ds est le plus petit*/
                            min = jet_des[j];
                            index_min = j;
                        }
                    }
                    jet_des[index_min] = 0;      /*Met la valeur du plus petit ds  0*/
                    for (min=0;min<4;min++)
                    {     /*Recopie les valeurs, except le 0*/
                        if (jet_des[min] != 0)
                        {
                            tabcaractemp[i] += jet_des[min]; /*Inscrit les valeurs dans le tableau*/
                            total_temp += jet_des[min];       /*Ajoute au total*/
                        }
                    }
                }
            } while ((total_temp<75) || (total_temp>90));
            if (total_temp > total)
            {        /*Dtermine si ce nouveau jet est le plus lev*/
                for(i=0;i<6;i++)
                    caracteristique[i] = tabcaractemp[i];
                total = total_temp;
            }
        }
        tri_int (caracteristique, 6);     /*tri le meilleur jet de carac*/
        for (j=0;j<6;j++)   /*Affiche les caractristique tire*/
            printf("\n%s %d: %d", acc("Caractristique",chfunc), j+1, caracteristique[j]);
        puts("");
        printf("%s %d\n", acc("Total des caractristiques=",chfunc), total);
    }
}

void niveau ()
{
    FILE* fichier;
    int max, val_max, val, b1, b2, nb_niveau, i=0, j, nb, niveau_mini, niveau_max, niveau;
    int *tab;
    char chaine[255];
    strcpy(chaine,Menu("..\\Donnes\\Menu_niveau.ini",chfunc,1,0));    /*Appel du menu de niveau*/
    if (!strcmp("Tranche",chaine))    /*Choix d'une tranche de niveaux*/
    {
        do
        {    /*Bcl erreur de saisie*/
            putsacc("Choisit le niveau minimum des personnages: ");
            niveau_mini = (int) interpret_calc("\0");
        } while (niveau_mini == NA || niveau_mini == defo);
        do
        {    /*Bcl erreur de saisie*/
            putsacc("Choisit le niveau maximum des personnages: ");
            niveau_max = (int) interpret_calc("\0");
        } while (niveau_max == NA || niveau_max == defo);
    }
    else
    {    /*Saisi des mini et maxi du niveau*/
        niveau_mini = atoi(chaine);    /*Lecture du niveau mini*/
        Efface_char(chaine,"-");
        niveau_max = atoi(chaine);        /*Lecture du niveau maxi*/
    }
    do
    {    /*Boucle d'erreur de saisie*/
        putsacc("Nb de personnages  tirer: ");
        nb = (int) interpret_calc("\0");
    } while (nb == NA || nb == defo);
    puts("");
    fichier = ouvre_fichier("..\\Donnes\\Niveau.niv","r");
    for(;nb>0;nb--)
    {
        fgets(chaine,255,fichier);
        Efface_char(chaine,"=");
        max = atoi(chaine);
        fgets(chaine,255,fichier);
        Efface_char(chaine,"=");
        val_max = atoi(chaine);
        nb_niveau = niveau_max - niveau_mini + 1;
        ER = (int) (tab = (int*) calloc(nb_niveau+1,sizeof(int)));   /*Cre le tableau des niveaux*/
        Erreur(1);
        j = niveau_mini - 1;   /*Valeur de dbut de boucle de remplissage du tableau*/
        i=0;
        if (niveau_mini <= max)
        {    /*Dbut du tableau*/
            do
            {  /*Recherche du niveau mini - 1*/
                fgets(chaine,255,fichier);
                val = atoi(chaine);
            } while (val != niveau_mini - 1);
            do
            {
                j++;
                Efface_char(chaine,":");
                tab[i++] = atoi(chaine);
                fgets(chaine,255,fichier);
            }while(j <= 25 && j <= niveau_max);
        }
        if (niveau_mini > max || niveau_max > max)
        {    /*Si le niveau dpasse la limite*/
            while(strstr(chaine,"niv+1:") == NULL)
                fgets(chaine,255,fichier);     /*Recherche la ligne des niveaux suprieurs*/
            Efface_char(chaine,":");
            Efface_char(chaine,"+");
            val = atoi(chaine);     /*Prend la valeur de l'augmentation  chaque niveau*/
            do
            {
                val_max += val;
                j++;
                tab[i++] = val_max;
            }while(j <= niveau_max);
        }
        b1 = tab[0]+1;        /*Prend la 1ere case du tableau*/
        b2 = tab[i-1];      /*Prend la dernire case du tableau*/
        val = NbAlea2b(b1,b2);
        for(i=1;i<nb_niveau+1;i++)
        {    /*Cherche la valeur tire dans le tableau*/
            if (val <= tab[i])
                break;
        }
        niveau = i + niveau_mini - 1;
        printf("Niveau du personnage: %d\n", niveau);
        rewind(fichier);
        free(tab);
    }
    fclose(fichier);
}

void Trait_physique ()
{
    FILE* fichiertable;     /*Pointe le mme fichier, mais sert  utiliser les tables alatoires*/
    FILE* Trait_physiques;  /*Pointe le mme fichier, mais sert aux lignes des diffrents traits physiques*/
    char chaine[255];
    char Trait[255];
    int index, alea, compt0, cpt0;    /*Pour gen alea*/
    strcpy(chaine,"..\\Donnes\\Traits physiques\\Trait physiques ");
    strcpy(Trait,Menu("..\\Donnes\\Menu_race.ini",chfunc,1,0));    /*Rutilise Trait pour stocker la race*/
    strcat(chaine,Trait);
    strcat(chaine," ");
    strcpy(Trait,Menu("..\\Donnes\\Menu_sexe.ini",chfunc,1,0));    /*Rutilise Trait pour stocker la sexe*/
    strcat(chaine,Trait);
    strcat(chaine,".tbl");
    fichiertable = ouvre_fichier(chaine,"r");
    Trait_physiques = ouvre_fichier(chaine,"r");
    puts("");
    fgets(Trait,255,Trait_physiques);    /*Saisi le premier trait physique*/
    do
    {
        Trait[0] = '#';    /*Remplace le '_' par un '#' pour la recherche des tables*/
        Efface_n(Trait);      //Retire le \n
        rewind(fichiertable);
        fgets(chaine,255,fichiertable);
        while (strcmp(chaine,Trait))    /*Repre la table du trait physique slectionn*/
        {
            fgets(chaine,255,fichiertable);
            if (chaine[0] == '#')
                Efface_n(chaine);      //Retire le \n
        }
        /*Gen alea modifi*/
        index=-1;
        compt0=0;
        fgets(chaine,255,fichiertable);
        alea = jet_de_des_gen_alea(&index,chaine);      /*jet alatoire du 1er d de la table*/
        while (alea != 0)        /*Tant qu'un d est lanc*/
        {
            compt0++;
            while (verif_val_gen_alea (&index, chaine, alea) != 1)  /*Tant que la bonne valeur n'est pas trouve*/
            {
                fgets(chaine,255,fichiertable);
                index = 0;
                for(cpt0=0;(cpt0<compt0) && (chaine[index]=='0');cpt0++)  /*Ignore les 0 de la table*/
                    index+=2;
                index--;
            }
            compt0++;
            alea = jet_de_des_gen_alea(&index,chaine); /*Vrifie si un d doit tre lanc, et le lance le cas chant*/
        }
        strcpy(chaine,string_gen_alea (index,chaine));   /*Isole la chaine de caractre*/
        Trait[0] = ' ';    /*Remplace le '#' par un espace*/
        printf("%s: ", acc(Trait,chfunc));
        printf("%s\n", acc(chaine,chfunc));
        fgets(Trait,255,Trait_physiques);    /*Saisi le trait physique suivant*/
    }while(Trait[0] != '.');
    fclose(fichiertable);
    fclose(Trait_physiques);
}

void stades_blessures ()
{
    float PV;
    do
    {    /*Bcl erreur de saisie*/
        printf("Nombre de points de vie du personnage: ");
        PV = interpret_calc("\0");
    } while (PV == NA || PV == defo);
    printf("\nStades de blessures:\n");
    printf("Indemne:         %.0f pv\n", PV);
    printf("Blessure %s:  %.0f pv\n", acc("lgre",chfunc), floor(PV/5*4));
    printf("Blessure grave:   %.0f pv\n", floor(PV/5*3));
    printf("Handicap:         %.0f pv\n", floor(PV/5*2));
    printf("%s:       %.0f pv\n", acc("Hmorragie",chfunc), floor(PV/5));
    printf("Coma:            0 pv\n");
    printf("Mort:            -10 pv\n");
}

void calcul_IMC()
{
    FILE* fichier;
    char chaine[255];
    char race[100];
    char sexe[20];
    float IMC;
    float IMCtab[6];
    int i, taille, poids;
    float tailleM;
    strcpy(race,Menu("..\\Donnes\\Menu_race.ini",chfunc,1,0));
    strcpy(sexe,Menu("..\\Donnes\\Menu_sexe.ini",chfunc,1,0));
    do
    {    /*Bcl erreur de saisie*/
        printf("Taille du personnage (en cm): ");
        taille = (int) interpret_calc("\0");
    } while (taille == NA || taille == defo);
    do
    {    /*Bcl erreur de saisie*/
        printf("Poids du personnage (en kg): ");
        poids = (int) interpret_calc("\0");
    } while (poids == NA || poids == defo);
    fichier = ouvre_fichier("..\\Donnes\\Poids_taille_age.ini","r");
    while (strstr(chaine,race) == NULL)
    {    /*Recherche la ligne de la race*/
        fgets(chaine,255,fichier);
    }
    while (strstr(chaine,sexe) == NULL)
    {    /*Recherche la ligne du sexe*/
        fgets(chaine,255,fichier);
    }
    fgets(chaine,255,fichier);  //Saute #classe 1
    fgets(chaine,255,fichier);            /*Saisi la ligne contenant les donnes*/
    for (i=0;i<10;i++)
    {    //Saute les 9 donnes superflues
        Efface_char(chaine,"=");
    }
    /*Lit les 6 valeur d'IMC*/
    Efface_char(chaine,"=");
    IMCtab[0] = atof(chaine);
    for (i=1;i<6;i++)
    {
        Efface_char(chaine,",");
        IMCtab[i] = atof(chaine);
    }
    tailleM = (float) taille/100;
    IMC = (poids/(tailleM*tailleM));    /*IMC = poids/taille au carr. Taille divis par 100 pour avoir en mtre*/
    if(IMC < IMCtab[0])
        putsacc("Dnutrition\n");
    else if(IMC < IMCtab[1])
        printf("Maigreur\n");
    else if(IMC < IMCtab[2])
        printf("Corpulence normale\n");
    else if(IMC < IMCtab[3])
        printf("Surpoids\n");
    else if(IMC < IMCtab[4])
        putsacc("Obsit modre\n");
    else if(IMC < IMCtab[5])
        putsacc("Obsit svre\n");
    else   /*Suprieur ou gal  IMCtab[5]*/
        putsacc("Obsit massive\n");
    fclose(fichier);
}

int verif_val_gen_alea (int* index, char* ligne, int alea) /*Vrifie les valeurs de la table pour trouver la bonne ligne*/
{
    int val1, val2;
    char valA[5] = "0";
    char valB[5] = "0";
    char temp[2];
    while (((ligne[*index+1]) != ':') && ((ligne[*index+1]) != '-'))
    {
        temp[0] = ligne[++*index];    /*Saisi la premire valeur*/
        temp[1] = '\0';
        strcat(valA,temp);
    }
    val1 = atoi(valA);
    val2 = val1;    /*2e valeur = 1ere, par defaut*/
    if (ligne[*index+1] == '-')    /*Si il y a une 2e valeur*/
    {
        ++*index;
        while ((ligne[*index+1]) != ':')    /*Saisi la 2e valeur*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(valB,temp);
        }
        val2 = atoi(valB);
    }
    ++*index;
    if ((alea >= val1) && (alea <= val2))
        return 1; /*Renvoi 1 si les valeurs correpondent au jet de d*/
    return 0;    /*Renvoi 0 sinon*/
}

int jet_de_des_gen_alea (int* index, char* ligne)
{                   /*Vrifie qu'un d doit tre lanc et le lance*/
    int alea, borne;
    char fasdes[5] = "0";
    char temp[2];
    ++*index;
    if ((ligne[*index] == 'd') && (ligne[++*index] == 'd'))      /*Si un d doit tre lanc*/
    {
        while (ligne[*index+1] != ':')    /*Lit la valeur du d*/
        {
            temp[0] = ligne[++*index];
            temp[1] = '\0';
            strcat(fasdes,temp);
        }
        ++*index;
        borne = atoi(fasdes);
        alea = NbAlea1b(borne);            /*Effectue le jet de d*/
        return alea;
    }
    else
        return 0;        /*Renvoi 0 si aucun d n'est  lancer*/
}

char* string_gen_alea (int index, char* ligne)
{
    int i=0;
    char string[255];
    while (index < (int)strlen(ligne))    /*Copie ce qui doit tre renvoy dans "string"*/
        string[i++] = ligne[index++];
    string[i-1] = '\0';
    strcpy(ligne,string);
    return ligne;
}
