/* Programme de jets d'attaque multiple pour donjons et dragons 3.5 modifi.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.1. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include "Utilitaire.h"
#include "Rand.h"
#include "Jdr.h"

int main (int argc,char *argv[])
{
    int bonus_att, esquiv, jet_att, jet_perf, resist, bonus_perf, *loc, nb_attac, *critic, i, niv_critic, temp;
    Init_srand();
    init_historique_saisie();
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    Titre (argc,argv,"Attaques multiples","Module d'attaques multiples de Donjons et dragons",color_sd("Attaques multiples",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    do
    {
        do
        {    /*bcl d'erreur de saisie*/
            putsacc("Nombre d'attaques  effectuer: ");
            nb_attac = (int) interpret_calc("\0");
        } while (nb_attac == NA || nb_attac == defo);
        puts("");
        do
        {    /*bcl d'erreur de saisie*/
            printf("Bonus d'attaque: +");
            bonus_att = (int) interpret_calc("\0");
        } while (bonus_att == NA || bonus_att == defo);
        do
        {    /*bcl d'erreur de saisie*/
            printf("Esquive: ");
            esquiv = (int) interpret_calc("\0");
        } while (esquiv == NA || esquiv == defo);
        do
        {    /*bcl d'erreur de saisie*/
            printf("Critique (20): ");
            niv_critic = (int) interpret_calc("\0");
            if (niv_critic == defo)    /*par defaut, le critique est fix  20*/
                niv_critic = 20;
        } while (niv_critic == NA);
        ER = (int) (loc = (int*) calloc(nb_attac,sizeof(int)));   /*Taille tableau = nb d'attaque*/
        Erreur(1);
        ER = (int) (critic = (int*) calloc(nb_attac,sizeof(int)));
        Erreur(1);
        for (i=0;i<nb_attac;i++)    /*Boucle sur le nombre d'attaque*/
        {
            jet_att = NbAlea1b(20);    /*Effectue le jet d'attaque*/
            printf("Attaque %d: %d,%d", i+1, jet_att, jet_att+bonus_att);/*Affiche le numro de l'attaque, le jet naturel et modifi*/
            if (jet_att == 1)
            {
                critic[i] = -1*NbAlea1b(20);  /*Echec critique not en valeur ngative*/
                printf("     ! Echec critique ! (%d).\n", -1*critic[i]);
                continue;    /*Reboucle sur le nombre d'attaque*/
            }
            if (jet_att >= niv_critic)
            {        /*Possibilit de critique*/
                resist = NbAlea1b(20)+bonus_att;    /*Reutilise variable resist pour confirmation du critic*/
                if (resist >= esquiv)
                {
                    critic[i] = 1;     /*Critique confirm not par 1*/
                    printf(":%d     Attaque critique\n", resist);
                    continue;  /*Reboucle sur le nombre d'attaque*/
                }
            }
            if (jet_att+bonus_att >= esquiv)
            {
                putsacc("     Adversaire touch...\n");
                loc[i] = NbAlea1b(20);    /*Localisation (signifie aussi attaque touche*/
            }
            else
                putsacc("     Attaque rate.\n");
        }
        Pause();
        bonus_perf = 0;
        resist = 0;
        for (i=0;i<nb_attac;i++) /*Bcl su rle nb d'attaque*/
        {
            if (loc[i])    /*Si localisation: jet de perforation*/
            {
                printf("Attaque %d:            Localisation:%d (%s): ", i+1,loc[i], acc("humanode",chfunc));   /*Affiche le jet de localisation*/
                if (loc[i] <= 5)            /*Affiche la localisation humanode*/
                    puts("Jambes");
                if (loc[i] >= 6 && loc[i] <= 12)
                    puts("Torse");
                if (loc[i] >= 13 && loc[i] <= 15)
                    puts("Bras gauche");
                if (loc[i] >= 16 && loc[i] <= 18)
                    puts("Bras droit");
                if (loc[i] == 19 || loc[i] == 20)
                    putsacc("Tte (partie sensible!)\n");
                do
                {    /*bcl d'erreur de saisie*/
                    printf("Bonus de perforation (%d): +", bonus_perf);
                    temp = (int) interpret_calc("\0");
                    if (temp == defo)     /*par defaut, bonus_perf ne change pas de valeur*/
                        temp = bonus_perf;
                } while (temp == NA);
                bonus_perf = temp;
                do
                {    /*bcl d'erreur de saisie*/
                    printf("%s (%d): ", acc("Rsistance de l'adversaire",chfunc), resist);
                    temp = (int) interpret_calc("\0");
                    if (temp == defo)     /*Idem pour resistance*/
                        temp = resist;
                } while (temp == NA);
                resist = temp;
                jet_perf = 0;
                do
                {  /*Bcl si critique sur jet de perforation*/
                    jet_perf+= NbAlea1b(20);
                } while (jet_perf == 20);
                if(jet_perf >= 20)
                    puts("Critique de perforation!!!");
                printf("%d,%d", jet_perf, jet_perf+bonus_perf);
                if (jet_perf+bonus_perf < resist)
                {
                    putsacc("     L'attaque n'a pas blesse l'adversaire\n\n");
                    loc[i] = 0;    /*Attaque rate, localisation  0*/
                }
                else
                    putsacc("     * Attaque russie, l'adversaire est bless *\n\n");
            }
        }
        printf("\n\nBilan des %d attaques:\n",nb_attac);
        for (i=0;i<nb_attac;i++)    /*Bcl sur nb d'attaque pour bilan des attaques russie*/
        {
            if (loc[i] || critic[i])    /*Si attaque russie ou critique*/
            {
                printf("Attaque %d: ", i+1);
                if (critic[i] == 1)
                {            /*Attaque critique, + localisation*/
                    printf("!!! Attaque critique ");
                    loc[i] = NbAlea1b(20);
                }
                if (critic[i] < 0)
                {            /*Echec critique, affiche le jet de critic*/
                    printf("!!! Echec critique, %d\n", -1*critic[i]);
                    continue;    /*Rebcl, ignorant la localisation*/
                }
                else
                    printf("touche ");   /*Sinon attaque russie simplement*/
                if (loc[i] <= 5)       /*Localisation humanode*/
                    printf("au jambes (%d)\n",loc[i]);
                if (loc[i] >= 6 && loc[i] <= 12)
                    printf("au torse (%d)\n",loc[i]);
                if (loc[i] >= 13 && loc[i] <= 15)
                    printf("au bras gauche (%d)\n",loc[i]);
                if (loc[i] >= 16 && loc[i] <= 18)
                    printf("au bras droit (%d)\n",loc[i]);
                if (loc[i] == 19 || loc[i] == 20)
                    printf("%s (%d)\n", acc(" la tte (partie sensible!)",chfunc), loc[i]);
            }
        }
        puts("");
        free(critic);
        free(loc);
    }while (1);
    return 0;
}
