/* Programme principal pour Servus domini.
Programm par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.1.*/
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "Utilitaire.h"
#include "Menu.h"
#include "Jdr.h"
#include "Fichier.h"

void Principale (int argc,char *argv[], int xtermOK);
char* Menu_des (char* lecture);

int main(int argc,char *argv[])
{
    int xtermOK;
    init_historique_saisie();
    xtermOK = system("xterm +hold -e exit");   //Effectue un appel de xterm et le fait quitter immdiatemment. Pour tester sa prsence.
    do
    {
        Principale(argc,argv,xtermOK);
    } while (1);
    return 0;
}

void Principale (int argc,char *argv[], int xtermOK)
{
    int i=0,j=0;
    char ligne[250];
    char chemin[150];
    char nomfichier[100];
    char command[250] = " ";
    system(CLEARSCREEN);
    Titre (argc,argv,"Servus domini v5.2","Programme principal de Servus domini",color_sd("Servus domini",chfunc,argv));
    strcpy(ligne,Menu_des(chfunc));
    /*Gestion des accents dans le menu!*/
    #ifndef WIN32    /*linux*/
    strcpy(ligne,acc(ligne,chfunc));
    #endif
    if(strcmp(ligne,"DES"))     //Si lancement de ds, pas d'xecution de programme
    {
        if (strstr(ligne,"\\") != NULL)
        {
            while(ligne[i] != '\\')
            {
                chemin[i] = ligne[i];
                i++;
            }
            chemin[i] = '\0';
            i++;
        }
        else
            chemin[0] = '\0';
        for(;i<(int)strlen(ligne);i++)
            nomfichier[j++] = ligne[i];
        nomfichier[j] = '\0';
        if (chemin[0] != '\0')
        {
            strcat(command,"cd \"");
            changeslash(chemin);    //Inerse les slash pour linux (le cas chant)
            strcat(command,chemin);
        }
        #ifdef WIN32    /*win*/
        strcat(command,"\" & ");
        strcat(command,"start ");
        strcat(command,nomfichier);
        #else   //linux
        strcat(command,"\"; ./");
        strcat(command,nomfichier);
        command[strlen(command)-4] = '\0';  //Supprime .exe
        if(!xtermOK)    //xterm est prsent
            strcat(command," swxterm &");   //Redonne la main aprs excution
        else    //xterm non trouv
            strcat(command," swxterm");     //Ne redonne pas la main, sous peine de perdre le focus sur le programme appel. Et de se retrouver avec un retour direct sur le menu.
        #endif
        system(command);
    }
}

char* Menu_des (char* lecture)
{
    FILE* temp;
    FILE* FichierMenu;
    int i, choix=-1; /*Valeur par defaut pour choix*/
    char menu='1';
    char affich [255];
    char cmdsys [255];
    FichierMenu = ouvre_fichier("Menu principal.ini","r");
    while (feof(FichierMenu) == 0)
    {
        fgets(lecture,255,FichierMenu);
        if ((strstr(lecture,"menu=") != NULL) && (menu==lecture[5]))   /*Si le menu correspondant est trouv*/
        {
            temp = ouvre_fichier("menu.tmp","w");        /*Fichier temporaire*/
            fgets(lecture,250,FichierMenu);
            printf("\n%s", acc(lecture,chfunc));            /*Titre du menu*/
            fgets(lecture,250,FichierMenu);
            while((strstr(lecture,"menu=") == NULL) && (feof(FichierMenu) == 0))
            {                  /*Tant que le menu n'est pas compltement lu*/
                fprintf(temp,"%s",lecture);  /*Inscrit le menu dans le fichier temporaire*/
                i=0;
                while (lecture[i] != ':')
                {
                    affich[i] = lecture[i];
                    i++;
                }
                affich [i] = '\0';
                printf("%s\n", acc(affich,chfunc));  /*Affiche le menu  l'cran*/
                fgets(lecture,250,FichierMenu);
            }
            fclose(temp);
            temp = ouvre_fichier("menu.tmp","r");  /*Lit le menu actuel dans le fichier temporaire*/
            printf("?: ");
            strcpy(affich,nomajloc_des(chfunc));
            if(strstr(affich,"d"))
            {   //Lancement de ds au lieu de choix de menu
                puts("");
                #ifdef WIN32    /*win*/
                sprintf(cmdsys,"cd \".\\Programmes divers\" && Simulateur_des.exe Des=\"%s\" Affichage=2", affich);
                #else /*linux*/
                sprintf(cmdsys,"cd \"./Programmes divers\" && ./Simulateur_des Des=\"%s\" Affichage=2", affich);
                #endif
                system(cmdsys); /*Appel le gnrateur de ds en ligne de commande*/
                Pause();
                strcpy(lecture,"DES");
                return lecture;
            }
            choix = atoi(affich);   /*Prend la saisie de l'utilisateur*/
            if(choix == QUIT)
            {
                fclose(temp);
                fclose(FichierMenu);
                exit(0);
            }
            if (choix == NA) /*Si l'utilisateur presse entre*/
                choix = -2;    /*Choix prend -2, ce qui renverra  Fuck*/
            while (feof(temp) == 0)
            {
                fgets(lecture,250,temp);
                if (atoi(lecture) == choix)   /*Vrifie que le nombre correspond au choix*/
                {
                    fclose(temp);
                    Efface_char(lecture,":");
                    if (strstr(lecture,"menu-") == NULL)
                    {                /*Si c'est ne pas un changement de menu*/
                        Efface_n(lecture);      //Retire le \n
                        fclose(FichierMenu);
                        return (lecture);   /*Renvoi la saisi (sans le : et le retour ligne*/
                    }
                    menu = lecture[5];     /*Lit le numero du menu*/
                    rewind(FichierMenu);
                    choix = -1;
                    break;
                }
            }
            if (choix != -1)
            {
                Fuck();
                rewind(FichierMenu);
            }
        }
    }
    printf("Erreur dans le fichier de menu, le menu %c n'a pas %s\n", menu, acc("t trouv.",chfunc));
    fclose(temp);
    fclose(FichierMenu);
    DPause();
    exit(0);
}
