#/bin/bash

source="Utilitaires/Sources desktop sh"
cible_kde="$HOME/.kde/share/kde4/services/ServiceMenus"
cible_gnome="$HOME/.gnome2/nautilus-scripts/Servus Domini"
cd ..
/bin/bash "./Rendre executable.sh"
# KDE
if [ -d $HOME/.kde/share/kde4/services/ ]; then
  echo "Dossiers de KDE trouvés"
  if [ -d $HOME/.kde/share/kde4/services/ServiceMenus/ ]; then
    echo "Dossier ServiceMenus existant"
  else
    echo "Dossier ServiceMenus inexistant"
    mkdir $HOME/.kde/share/kde4/services/ServiceMenus/
    echo "Dossier ServiceMenus créé"
  fi
  echo "Créations des fichiers desktop"
  echo "Conv_txthtml"
  cp -f "$source/Conv_txthtml.desktop.frag1" "$source/Conv_txthtml.desktop"
  echo -n $PWD >> "$source/Conv_txthtml.desktop"
  more "$source/Conv_txthtml.desktop.frag2" >> "$source/Conv_txthtml.desktop"
  mv -f "$source/Conv_txthtml.desktop" "$cible_kde/Conv_txthtml.desktop"
  echo "Conv_txthtml desktop en place"
  echo "Conv_htmltxtp"
  cp -f "$source/Conv_htmltxtp.desktop.frag1" "$source/Conv_htmltxtp.desktop"
  echo -n $PWD >> "$source/Conv_htmltxtp.desktop"
  more "$source/Conv_htmltxtp.desktop.frag2" >> "$source/Conv_htmltxtp.desktop"
  mv -f "$source/Conv_htmltxtp.desktop" "$cible_kde/Conv_htmltxtp.desktop"
  echo "Conv_htmltxtp desktop en place"
  echo "Testeur_table"
  cp -f "$source/Testeur_table.desktop.frag1" "$source/Testeur_table.desktop"
  echo -n $PWD >> "$source/Testeur_table.desktop"
  more "$source/Testeur_table.desktop.frag2" >> "$source/Testeur_table.desktop"
  mv -f "$source/Testeur_table.desktop" "$cible_kde/Testeur_table.desktop"
  echo "Testeur_table desktop en place"
else
 echo "Dossiers de KDE non trouvés."
fi

# GNOME
if [ -d $HOME/.gnome2/ ]; then
  echo "Dossiers de gnome trouvés"
  if [ -d $HOME/.gnome2/nautilus-scripts/ ]; then
    echo "Dossier nautilus-scripts existant"
  else
    echo "Dossier nautilus-scripts inexistant"
    mkdir $HOME/.gnome2/nautilus-scripts/
    echo "Dossier nautilus-scripts créé"
  fi
  mkdir "$HOME/.gnome2/nautilus-scripts/Servus Domini"
  echo "Créations des scripts nautilus"
  echo "Conv_txthtml"
  cp -f "$source/Conv_txthtml.sh.frag1" "$source/Conv_txthtml.sh"
  echo -n $PWD >> "$source/Conv_txthtml.sh"
  more "$source/Conv_txthtml.sh.frag2" >> "$source/Conv_txthtml.sh"
  mv -f "$source/Conv_txthtml.sh" "$cible_gnome/Conv_txthtml.sh"
  chmod +x "$cible_gnome/Conv_txthtml.sh"
  echo "script Conv_txthtml sh en place"
  echo "Conv_htmltxtp"
  cp -f "$source/Conv_htmltxtp.sh.frag1" "$source/Conv_htmltxtp.sh"
  echo -n $PWD >> "$source/Conv_htmltxtp.sh"
  more "$source/Conv_htmltxtp.sh.frag2" >> "$source/Conv_htmltxtp.sh"
  mv -f "$source/Conv_htmltxtp.sh" "$cible_gnome/Conv_htmltxtp.sh"
  chmod +x "$cible_gnome/Conv_htmltxtp.sh"
  echo "script Conv_htmltxtp sh en place"
  echo "Testeur_table"
  cp -f "$source/Testeur_table.sh.frag1" "$source/Testeur_table.sh"
  echo -n $PWD >> "$source/Testeur_table.sh"
  more "$source/Testeur_table.sh.frag2" >> "$source/Testeur_table.sh"
  mv -f "$source/Testeur_table.sh" "$cible_gnome/Testeur_table.sh"
  chmod +x "$cible_gnome/Testeur_table.sh"
  echo "script Testeur_table sh en place"
else
 echo "Dossiers de gnome non trouvés."
fi

#MIME
if [ -d $HOME/.local/share/mime/packages/ ]; then
  echo "Dossier ~/.local/share/mime/packages existant"
else
  echo "Dossier ~/.local/share/mime/packages inexistant"
  mkdir $HOME/.local/share/mime/packages
  echo "Dossier ~/.local/share/mime/packages créé"
fi
echo "Ajout du type mime text/tbl"
cp -f "$source/tbl.xml" "$HOME/.local/share/mime/packages/tbl.xml"
echo "Ajout du type mime text/txtp"
cp -f "$source/txtp.xml" "$HOME/.local/share/mime/packages/txtp.xml"
echo "Mise à jour de la base de donnée mime"
update-mime-database ~/.local/share/mime
echo "Fin de l'intégration au menu contextuel"
